/**************************************************************************
  ARBRE EN JAVASCRIPT COMPATIBLE IE5 / NE6
**************************************************************************/

// tableaux pour les noeuds
var nodes		= new Array();;
var openNodes	= new Array();

// tableaux pour les icones
var icons		= new Array(6);

// chargement des icones
function preloadIcons() {
	icons[0] = new Image();
	// TMO : JIRA JBNCG
	icons[0].src = "charte/image/arbre/plus.gif";
	icons[1] = new Image();
	icons[1].src = "charte/image/arbre/plusbottom.gif";
	icons[2] = new Image();
	icons[2].src = "charte/image/arbre/minus.gif";
	icons[3] = new Image();
	icons[3].src = "charte/image/arbre/minusbottom.gif";
	icons[4] = new Image();
	icons[4].src = "charte/image/arbre/folder.gif";
	icons[5] = new Image();
	icons[5].src = "charte/image/arbre/folderopen.gif";
}
// creation de l'arbre
function createTree (arrName, startNode, openNode) {
	nodes = arrName;
	if (nodes.length > 0) {
		preloadIcons();
		if (startNode == null) startNode = 0;
		if (openNode != 0 || openNode != null) setOpenNodes(openNode);
	
		if (startNode !=0) {
			var nodeValues = nodes[getArrayId(startNode)].split("|");
			document.write("<a href=\"" + nodeValues[3] + "\" onmouseover=\"window.status='" + nodeValues[2].replace(/\'/g, "\\\'") + "';return true;\" onmouseout=\"window.status=' ';return true;\"><img src=\"charte/image/arbre/folderopen.gif\" align=\"absbottom\" alt=\"\" />" + nodeValues[2].replace(/\'/g, "\\\'") + "</a><br />");
		}
		else
			document.write("<img src=\"charte/image/arbre/base.gif\" align=\"absbottom\" alt=\"\" /><span class='textbold'>" + TreeName + "</span><br />");
		
		var recursedNodes = new Array();
		addNode(startNode, recursedNodes);
	}
}
// retourne la position d'un noeud
function getArrayId(node) {
	for (i=0; i<nodes.length; i++) {
		var nodeValues = nodes[i].split("|");
		if (nodeValues[0]==node) return i;
	}
}
// Puts in array nodes that will be open
function setOpenNodes (openNode) {
	for (i=0; i<nodes.length; i++) {
		var nodeValues = nodes[i].split("|");
		if (nodeValues[0]==openNode) {
			openNodes.push(nodeValues[0]);
			setOpenNodes(nodeValues[1]);
		}
	} 
}
// verif. le noeud est ouvert
function isNodeOpen (node) {
	for (i=0; i < openNodes.length; i++)
		if (openNodes[i]==node) return true;
	return false;
}
// verif. le noeud a un fils
function hasChildNode (parentNode) {
	for (i=0; i< nodes.length; i++) {
		var nodeValues = nodes[i].split("|");
		if (nodeValues[1] == parentNode) return true;
	}
	return false;
}
// verif. le noeud est un noeud terminal
function lastSibling (node, parentNode) {
	var lastChild = 0;
	for (i=0; i< nodes.length; i++) {
		var nodeValues = nodes[i].split("|");
		if (nodeValues[1] == parentNode)
			lastChild = nodeValues[0];
	}
	if (lastChild==node) return true;
	return false;
}
// ajout d'un noeud
function addNode(parentNode, recursedNodes) {
	for (var i = 0; i < nodes.length; i++) {

		var nodeValues = nodes[i].split("|");
		if (nodeValues[1] == parentNode) {
			
			var ls	= lastSibling(nodeValues[0], nodeValues[1]);
			var hcn	= hasChildNode(nodeValues[0]);
			var ino = isNodeOpen(nodeValues[0]);

			// Write out line & empty icons
			for (g=0; g<recursedNodes.length; g++) {
				if (recursedNodes[g] == 1) document.write("<img src=\"charte/image/arbre/line.gif\" align=\"absbottom\" alt=\"\" />");
				else  document.write("<img src=\"charte/image/arbre/empty.gif\" align=\"absbottom\" alt=\"\" />");
			}

			// put in array line & empty icons
			if (ls) recursedNodes.push(0);
			else recursedNodes.push(1);

			// Write out join icons
			if (hcn) {
				if (ls) {
					document.write("<a href=\"javascript: oc(" + nodeValues[0] + ", 1);\"><img id=\"join" + nodeValues[0] + "\" src=\"charte/image/arbre/");
					 	if (ino) document.write("minus");
						else document.write("plus");
					document.write("bottom.gif\" align=\"absbottom\" alt=\"Open/Close node\" /></a>");
				} else {
					document.write("<a name=\"c" + nodeValues[0] + "\" href=\"javascript: oc(" + nodeValues[0] + ", 0);\"><img id=\"join" + nodeValues[0] + "\" src=\"charte/image/arbre/");
						if (ino) document.write("minus");
						else document.write("plus");
					document.write(".gif\" align=\"absbottom\" alt=\"Open/Close node\" /></a>");
				}
			} else {
				if (ls) document.write("<img src=\"charte/image/arbre/join.gif\" align=\"absbottom\" alt=\"\" />");
				else document.write("<img src=\"charte/image/arbre/joinbottom.gif\" align=\"absbottom\" alt=\"\" />");
			}

			// debut du lien HTML
			if (document.getElementById("treeNode") && document.getElementById("treeNode").value==nodeValues[0])
				document.write("<a id=\"c" + nodeValues[0] +"\" name=\"c" + nodeValues[0] + "\" CLASS=\"line-over\" href=\"" + nodeValues[3] + "\" onmouseover=\"window.status='" + nodeValues[2].replace(/\'/g, "\\\'") + "';return true;\" onmouseout=\"window.status=' ';return true;\" OnClick=\"unSel('"+nodeValues[0]+"','"+hcn+"');this.className='line-over';\">");
			else
				document.write("<a id=\"c" + nodeValues[0] +"\" name=\"c" + nodeValues[0] + "\" CLASS=\"unSelectedNode\" href=\"" + nodeValues[3] + "\" onmouseover=\"window.status='" + nodeValues[2].replace(/\'/g, "\\\'") + "';return true;\" onmouseout=\"window.status=' ';return true;\" OnClick=\"unSel('"+nodeValues[0]+"','"+hcn+"');this.className='line-over';\">");

			
			// Write out folder & page icons
			if (hcn) {
				document.write("<img id=\"icon" + nodeValues[0] + "\" src=\"charte/image/arbre/folder")
					if (ino) document.write("open");
				document.write(".gif\" align=\"absbottom\" alt=\"Folder\" />");
			} else document.write("<img id=\"icon" + nodeValues[0] + "\" src=\"charte/image/arbre/page.gif\" align=\"absbottom\" alt=\"Page\" />");
			
			// nom du noeud
			document.write("<span id=\"treeText"+i+"\">"+nodeValues[2]+"</span>");

			// fin du lien HTML
			document.write("</a><br />");
			
			// If node has children write out divs and go deeper
			if (hcn) {
				document.write("<div id=\"div" + nodeValues[0] + "\"");
					if (!ino) document.write(" style=\"display: none;\"");
				document.write(">");
				addNode(nodeValues[0], recursedNodes);
				document.write("</div>");
			}
			
			// remove last line or empty icon 
			recursedNodes.pop();
		}
	}
}
// ouvre ou ferme un noeud
function oc(node, bottom) {
	try{
		var theDiv = document.getElementById("div" + node);
		var theJoin	= document.getElementById("join" + node);
		var theIcon = document.getElementById("icon" + node);
		
		/*for (i=0;i<Tree.length;i++){
			tmpDiv = document.getElementById("div" + i);
			tmpJoin = document.getElementById("join" + node);
			tmpIcon = document.getElementById("icon" + node);
			if (!tmpDiv.style.display == 'none'){
				tmpIcon.src = icons[4].src;
				tmpJoin.src = icons[3].src;
				tmpDiv.style.display = 'none';
			}
		}*/
			
		if (theDiv.style.display == 'none') {
			if (bottom==1) theJoin.src = icons[3].src;
			else theJoin.src = icons[2].src;
			theIcon.src = icons[5].src;
			theDiv.style.display = '';
		} else {
			if (bottom==1) theJoin.src = icons[1].src;
			else theJoin.src = icons[0].src;
			theIcon.src = icons[4].src;
			theDiv.style.display = 'none';
		}
	}catch(e){
		//Y'a un bug
	}
}
// Push and pop not implemented in IE(crap!    dont know about NS though)
if(!Array.prototype.push) {
	function array_push() {
		for(var i=0;i<arguments.length;i++)
			this[this.length]=arguments[i];
		return this.length;
	}
	Array.prototype.push = array_push;
}
if(!Array.prototype.pop) {
	function array_pop(){
		lastElement = this[this.length-1];
		this.length = Math.max(this.length-1,0);
		return lastElement;
	}
	Array.prototype.pop = array_pop;
}

/****************************************************/
function unSel(selectedNode, hasChild) {
 var i = document.links.length;
 var j = 0;
 for (j=0;j<i;j++) {
  document.links[j].className="unSelectedNode";
 }
 if (document.getElementById("treeNode") && hasChild=="false")	{ 	
 	document.getElementById("treeNode").value==selectedNode;
	oldHref=document.getElementById("c"+selectedNode).href;
	document.getElementById("c"+selectedNode).href=oldHref+"&foc="+selectedNode;
 }
}
/****************************************************/
